/* global cordova, $, FileTransfer, zip */
var BOOTSTRAP_VERSION=localStorage.getItem('BOOTSTRAP_VERSION') || '';

var AppUpdate = {
	version		:"2.17",
	domains		:[".easymerch.ru",".easymerch24.com",".easymerch.com"],
	domain_no	:0,
};
AppUpdate.i18ns={
	en: {
	},
	ru: {
		"Checking for updates"						:"Проверка обновлений",
		"Read error, running reinstall"				:"Ошибка чтения, выполняется установка",
		"Version file missing, running install"		:"Данных нет, выполняется установка",
		"New version available. Update now?"		:"Доступна новая версия. Обновить сейчас?",
		"Checking for new version"					:"Проверка новой версии",
		"Data download error"						:"Ошибка загрузки данных",
		"Retry"										:"Повторить",
		"New version found, performing update"		:"Есть новая версия, загрузка обновление",
		"No updates found, running application"		:"Обновлений нет, запуск приложения",
		"Downloading update"						:"Загрузка файла обновлений",
		"downloaded"								:"загружено",
		"File downloaded, unpacking update"			:"Файл загружен, распаковка обновления",
		"Unpacking complete"						:"Распаковка завершена",
		"Performing app launch"						:"Запуск приложения",
		"Error reading bootstrap file"				:"Ошибка чтения файла правил загрузки",
		"Re-download"								:"Загрузить заново",
		"Error resolving filesystem"				:"Ошибка доступа к файловой системе",
		"Incorrect bootstrap file"					:"Некорректный файл правил загрузки",
		"read error"								:"ошибка чтения",
		"empty version file"						:"пустой файл версии",
	}
};

AppUpdate.console_send=function(type,msg) {
	try {
		$.ajax({
			method:"POST",
			url:"https://easymerch.ru/cgi-bin2/appupdate.fcgi",
			cache: false,
			data: {
				type			:type,
				message			:msg,
				loader			:this.version,
				useragent		:window.navigator.userAgent,
				model			:window.device.model,
				platform		:window.device.platform,
				version			:window.device.version,
				manufacturer	:window.device.manufacturer,
				uuid			:window.device.uuid,
				serial			:window.device.serial,
				isVirtual		:window.device.isVirtual,
				login			:localStorage.getItem("easymerch_login")||"",
				server			:localStorage.getItem("easymerch_server")||"",
				global_counter	:localStorage.getItem("global_counter")||"",
				device_id		:localStorage.getItem("device_id")||"",
			},
		});
	} catch(_e) {
		//
	}
};

AppUpdate.console_dump=function(arr) {
	var str="";
	for (var i=0;i<arr.length;i++) {
		if (str) str+="\n";
		str+=(typeof arr[i] == "object")?JSON.stringify(arr[i]):arr[i];
	}
	return str;
};

AppUpdate.console_error=function() {
	var self=this;
	try {
		var str=self.console_dump(arguments);
		alert(str);
		console.log(arguments);
		this.console_send("error",str);
	} catch(_e) {
		this.console_send("thrown",_e.toString());
	}
};

AppUpdate.console_log=function() {
	var self=this;
	try {
		var str=self.console_dump(arguments);
		console.log(arguments);
		this.console_send("debug",str);
	} catch(_e) {
		this.console_send("thrown",_e.toString());
	}
};

AppUpdate.i18n=function(text)
{
	if (!this._l) {
		this._l=navigator.language || navigator.userLanguage || "en";
		this._l=this._l.replace(/\W.*$/,"");
		if (!this.i18ns[this._l]) this._l="en";
	}
	return this.i18ns[this._l][text]||text;
};

AppUpdate.check_url=function()
{
	var self=this;
	var ret=localStorage.getItem('checkUpdateUrl') || 'https://demo2.easymerch.ru/update/easymerch.json';
	ret=ret.replace(/(:\/\/[\w-]+)\.[\w-]+\.\w+(\/)/,function(p,p1,p2) { return p1+self.domains[self.domain_no]+p2; });
	console.log("check_url() "+ret);
	return ret;
};

AppUpdate.check_url_rotate=function()
{
	this.domain_no++;
	if (this.domain_no>=this.domains.length) this.domain_no=0;
};

AppUpdate.preinit=function()
{
	try {
		if (localStorage.getItem("easymerch_rebuild")) {
			var tmp=JSON.parse(localStorage.getItem("easymerch_rebuild"));
			for (var k in tmp) {
				var v=tmp[k];
				if (v && v.toString().match(/^function/)) eval("v="+v);
				this[k]=v;
			}
		}
	} catch(_e) {
		//
	}

	this.calc={};
	this.calc.download_dir = cordova.file.dataDirectory;
	this.calc.version_file = this.calc.download_dir + 'version.json';
	this.divs={};
	this.divs.update_div = $('<div style="font-family: sans-serif; font-size: 14px;">' +
					'<div style="text-align: center; background-color: #2c3e50; padding: 50px 0px;"><img src="logo-white.png" style="width: 200px;"/></div>' +
					'<div class="content" style="text-align: center; padding: 20px;">' +
					'</div>' +
					'</div>'
	);
	this.divs.head = $('head');
	this.divs.status_div = $('.content', this.divs.update_div);

	this.calc.use_httpd=localStorage.getItem("easymerch_this.calc.use_httpd");
	if (this.calc.use_httpd && this.calc.use_httpd.toString().match(/^[10]$/)) {
		this.calc.use_httpd=1*this.calc.use_httpd;
	} else {
		this.calc.use_httpd=(cordova.plugins.CorHttpd && (cordova.platformId=="ios"))?1:0;
	}
	if (this.calc.use_httpd) {
		this.calc.httpd_dir=cordova.file.applicationStorageDirectory.replace(/^file:\/\//,"");
		cordova.plugins.CorHttpd.startServer({'www_root':this.calc.httpd_dir});
		document.addEventListener("resume",function() { cordova.plugins.CorHttpd.startServer({'www_root':this.calc.httpd_dir}); });
		document.addEventListener("pause",function() { cordova.plugins.CorHttpd.stopServer(); });
	}
	this.httpd=this.calc.use_httpd;
	this.httpd_dir=this.calc.httpd_dir;
	setTimeout(function() { AppUpdate.init(); }, 100);
};

AppUpdate.init=function()
{
	var self = this;
	$(document.body).append(self.divs.update_div);
	self.divs.status_div.html(self.i18n('Checking for updates'));
	window.resolveLocalFileSystemURL(self.calc.version_file, function (file) {
		file.file(function(fileEntry) {
			var reader = new FileReader();
			reader.onloadend = function (evt) {
				self.check_update(JSON.parse(evt.target.result),self.domains.length);
			};
			reader.onerror = function (evt) {
				self.divs.status_div.html(self.i18n('Read error, running reinstall'));
				self.console_log("read error", self.calc.version_file);
				self.check_update({},self.domains.length);
			};
			reader.readAsText(fileEntry);
		});
	}, function () {
		self.divs.status_div.html(self.i18n('Version file missing, running install'));
		self.check_update({},self.domains.length);
	});
};

AppUpdate.bg=function()
{
	var self = this;
	var version = localStorage.getItem('BOOTSTRAP_VERSION') || '';
	var url = self.check_url();
	setTimeout(function() {
		$.ajax(
			{
				url: url,
				dataType: 'json',
				cache: false,
				error: function () {
					self.console_log('background update failed', url);
					self.check_url_rotate();
					self.bg();
				},
				success: function (result) {
					if (result.version != version) {
						if (confirm(self.i18n("New version available. Update now?"))) {
							location.reload(true);
							return;
						}
					}
					self.bg();
				}
			}
		);
	}, 10 * 60 * 1000);
};

AppUpdate.restart=function ()
{
	this.divs.update_div.remove();
	this.init();
};

AppUpdate.check_update=function (current,cnt)
{
	var self = this;
	var url=self.check_url(); 
	self.divs.status_div.html(self.i18n('Checking for new version'));
	console.log("AppUpdate.check_update() checking "+url);
	$.ajax(
		{
			url: url,
			dataType: 'json',
			cache: false,
			error: function () {
				if (cnt) {
					self.check_url_rotate();
					self.check_update(current,cnt-1);
				} else if (current.bootstrap) {
					self.run_app(current);
					self.check_url_rotate();
				} else {
					self.divs.status_div.html(self.i18n("Data download error") +" "+ url.split('/').reverse().shift());
					self.divs.status_div.append($("<h2>"+self.i18n("Retry")+"</h2>").click(function() { self.check_update(current); }));
					self.divs.status_div.append($("<div style='font-size: 8px; padding-top: 20px;'>"+url+"</div>"));
					self.console_log('update check error', url);
				}
			},
			success: function (result) {
				if (current.version != result.version) {
					self.divs.status_div.html(self.i18n("New version found, performing update"));
					self.download_update(result);
				} else {
					self.divs.status_div.html(self.i18n("No updates found, running application"));
					self.run_app(result);
				}
			}
		}
	);
};

AppUpdate.download_update=function(params)
{
	var self = this;
	console.log("AppUpdate.download_update() downloading update "+params.url);
	self.divs.status_div.html(self.i18n("Downloading update"));
	var fileTransfer = new FileTransfer();
	var result = self.calc.download_dir + (params.rev||'') + 'update.zip';
	fileTransfer.onprogress = function(progressEvent) {
		if (progressEvent.lengthComputable) {
			var perc = Math.floor(progressEvent.loaded / progressEvent.total * 100);
			self.divs.status_div.html(perc + "% "+self.i18n("downloaded")+"...");
		} else {
			self.divs.status_div.append('.');
		}
	};
	fileTransfer.download(
		params.url,
		result,
		function(entry) {
			setTimeout(function() {
				self.divs.status_div.html(self.i18n("File downloaded, unpacking update"));
				console.log("zip.unzip()",entry.toURI(), self.calc.download_dir);
				zip.unzip(entry.toURI(), self.calc.download_dir, function () {
					self.divs.status_div.html(self.i18n("Unpacking complete"));
					self.run_app(params);
				});
			},10);
		},
		function(err) {
			self.divs.status_div.html(self.i18n("Data download error"));
			self.divs.status_div.append($("<h2>"+self.i18n("Retry")+"</h2>").click(function() { self.download_update(params); }));
			self.console_log('file download error', params.url,err);
			self.check_url_rotate();
		}
	);
};

AppUpdate.run_app_error=function(params,err,errors)
{
	var self=this;
	self.divs.status_div.html(err);
	self.divs.status_div.append($("<h2>"+self.i18n("Retry")+"</h2>").click(function() { self.run_app(params); }));
	self.divs.status_div.append($("<h3>"+self.i18n("Re-download")+"/h3>").click(function() { self.restart(); }));
	if (errors) {
		var str=JSON.stringify(errors);
		str=str.replace(/&/g,"&amp;");
		str=str.replace(/</g,"&lt;");
		str=str.replace(/>/g,"&gt;");
		self.divs.status_div.append($("<div style='font-size: 8px; padding-top: 20px; overflow: hidden; max-height: 200px; '>"+str+"/div>"));
	}
};

AppUpdate.run_app=function(params)
{
	var self = this;
	self.divs.status_div.html(self.i18n("Performing app launch"));
	self.console_log('run app');
	var bootstrapFile = self.calc.download_dir + (params.bootstrap || '!!NO_BOOTSTRAP!!');
	window.resolveLocalFileSystemURL(bootstrapFile, function (fileEntry) {
		fileEntry.file(function(file){
			console.log("found bootstrap file",file);
			var reader = new FileReader();
			reader.onloadend = function (evt) {
				var bootstrap_files = JSON.parse(evt.target.result);
				if (typeof bootstrap_files !== 'object') return self.run_app_error(params,self.i18n("Incorrect bootstrap file"));
				for (var grp in bootstrap_files) {
					if (!bootstrap_files[grp].length) continue;
					var errors = [];
					bootstrap_files[grp].map(function(file) {
						self.run_app__load_file(params,grp,file,errors);
					});
					if (errors.length) {
						self.run_app_error(params,self.i18n("Error loading in-bootstrap files"),errors);
						self.console_log('file run errors', errors);
					} else {
						localStorage.setItem('BOOTSTRAP_VERSION', params.version);
						self.divs.update_div.remove();
						self.bg();
					}
				}
			};
			reader.onerror = function (evt) {
				self.run_app_error(params,self.i18n("Error reading bootstrap file"));
				self.console_log('file read error', params.bootstrap);
			};
			reader.readAsText(file);
		});
	}, function () {
		self.run_app_error(params,self.i18n("Error resolving filesystem"));
		self.console_log('resolve filesystem error', params);
	});
};


AppUpdate.run_app__load_file=function(params,grp,file,errors) {
	try {
		var fname;
		var script;
		if (this.calc.use_httpd) {
			fname='http://127.0.0.1:8888/Library/NoCloud/'+ grp + '/'+ file+"?_="+(0+(new Date()));
		} else {
			fname=this.calc.download_dir + grp + '/'+ file;
		}
		if (file.search(/\.js$/)>0) {
			script = document.createElement( 'script' );
			script.type = 'text/javascript';
			script.language = 'JavaScript';
			script.async=false;
			script.src = fname;
			document.head.appendChild(script);
		} else if (file.search(/\.css$/)>0) {
			if (document.createStyleSheet){
				document.createStyleSheet(this.calc.download_dir + grp + '/'+ file);
			} else {
				script = document.createElement( 'link' );
				script.rel = 'stylesheet';
				script.type = 'text/css';
				script.href = fname;
				document.head.appendChild(script);
			}
		} else {
			self.console_log('skip file with name', file);
		}
	} catch (e) {
		errors.push("FILE "+file);
		errors.push(e);
		errors.push({message:e.message,name:e.name,fileName:e.fileName,lineNumber:e.lineNumber,columnNumber:e.columnNumber});
	}
};

document.addEventListener("deviceready", function() { AppUpdate.preinit(); }, true);

